using System;
using System.Collections.Generic;
using System.Text;

namespace SIPPBXv3
{
    public class GTOpACDMusicOnHold : GTOpAsync 
    {
        public SIPPBXACDHuntGroup _hg;
        public string _moh_dir;

        public GTOpACDMusicOnHold(GTOpAsyncCompound ac, GTSIPPBXEnv env, SIPPBXChan pbx_chan, string dtmfStr, SIPPBXACDHuntGroup hg, string moh_dir)
            :base(ac, env, pbx_chan, dtmfStr)
        {
            _hg = hg;
            _moh_dir = moh_dir;
        }

        public override void beginOp()
        {
            base.beginOp();
            LogoutText(4, "Start perform asyncronized step - GTOpACDMusicOnHold!");
            if(_hg.playMOH)
                getEnv().Send_StartMusicOnHold(getPBXChan().index, _hg.mohDir, getEnv().pbx.pbx_sys_set.bRandomPlayMOH?1:0, 0);
        }

        public override void abort()
        {
            base.abort();

            LogoutText(4, "Abort asyncronized step - GTOpACDMusicOnHold!");

            if (_hg.playMOH) 
                getEnv().Send_StopMusicOnHold(getPBXChan().index);
        }
    }
}
